/**********
Copyright 1990 Regents of the University of California.  All rights reserved.
Author: 1985 Thomas L. Quarles
**********/

#ifndef OPAMP
#define OPAMP


#include "ifsim.h"
#include "cktdefs.h"
#include "gendefs.h"
#include "complex.h"

/* information to describe a single instance */

typedef struct sOPAMPinstance {
    struct sOPAMPmodel *OPAMPmodPtr;
    struct sOPAMPinstance *OPAMPnextInstance;

    IFuid OPAMPname;
    int OPAMPstates;

    int OPAMPinplus;
    int OPAMPinminus;
    int OPAMPoutplus;
    int OPAMPinode; 

    double OPAMPCcomp;
    double OPAMPSRp;
    double OPAMPSRm;
    double OPAMPIoutp;
    double OPAMPIoutm;
    double OPAMPAv0;
    double OPAMPVt;
    double OPAMPRout;
    double OPAMPVoutm;
    double OPAMPVoutp;
    double OPAMPCMRR;
    double OPAMPVos;

    double *OPAMPinode_inplus;
    double *OPAMPinode_inode;
    double *OPAMPinplus_inplus;
    double *OPAMPinode_inminus;
    double *OPAMPinminus_inminus;
    double *OPAMPoutplus_outplus;
    double *OPAMPoutplus_inode;

    unsigned OPAMPCcompGiven:1;
    unsigned OPAMPSRpGiven:1;
    unsigned OPAMPSRmGiven:1;
    unsigned OPAMPIoutpGiven:1;
    unsigned OPAMPIoutmGiven:1;
    unsigned OPAMPAv0Given:1;
    unsigned OPAMPVtGiven:1;
    unsigned OPAMPRoutGiven:1;
    unsigned OPAMPVoutmGiven:1;
    unsigned OPAMPVoutpGiven:1;
    unsigned OPAMPCMRRGiven:1;
    unsigned OPAMPVosGiven:1;
} OPAMPinstance ;

/* per model data */

typedef struct sOPAMPmodel { 
    int OPAMPmodType;
    struct sOPAMPmodel *OPAMPnextModel;
    OPAMPinstance * OPAMPinstances;
    IFuid OPAMPmodName;
} OPAMPmodel;

/* device parameters */
#define OPAMP_CCOMP 1
#define OPAMP_SRP 2
#define OPAMP_SRM 3
#define OPAMP_IOUTP 4
#define OPAMP_IOUTM 5
#define OPAMP_AV0 6
#define OPAMP_VT 7
#define OPAMP_ROUT 8
#define OPAMP_VOUTM 9
#define OPAMP_VOUTP 10
#define OPAMP_CMRR 11
#define OPAMP_VOS 12

/* model parameters */

#include "opampext.h"

#endif /*OPAMP*/
