/**********
Copyright 1990 Regents of the University of California.  All rights reserved.
Author: 1985 Thomas L. Quarles
**********/
/*
 */

#include "spice.h"
#include <stdio.h>
#include "util.h"
#include "opampdefs.h"
#include "sperror.h"
#include "suffix.h"


int
OPAMPmDelete(inModel,modname,kill)
    GENmodel **inModel;
    IFuid modname;
    GENmodel *kill;
{
    OPAMPmodel **model = (OPAMPmodel**)inModel;
    OPAMPmodel *modfast = (OPAMPmodel *)kill;
    OPAMPinstance *here;
    OPAMPinstance *prev = NULL;
    OPAMPmodel **oldmod;
    oldmod = model;
    for( ; *model ; model = &((*model)->OPAMPnextModel)) {
        if( (*model)->OPAMPmodName == modname || 
                (modfast && *model == modfast) ) goto delgot;
        oldmod = model;
    }
    return(E_NOMOD);

delgot:
    *oldmod = (*model)->OPAMPnextModel; /* cut deleted device out of list */
    for(here = (*model)->OPAMPinstances ; here ; here = here->OPAMPnextInstance) {
        if(prev) FREE(prev);
        prev = here;
    }
    if(prev) FREE(prev);
    FREE(*model);
    return(OK);

}
