/**********
Copyright 1990 Regents of the University of California.  All rights reserved.
Author: 1985 Thomas L. Quarles
**********/
/*
 */

#include "spice.h"
#include <stdio.h>
#include "cktdefs.h"
#include "resdefs.h"
#include "sperror.h"
#include "suffix.h"


/*ARGSUSED*/
int
RESload(inModel,ckt)
    GENmodel *inModel;
    CKTcircuit *ckt;
        /* actually load the current resistance value into the 
         * sparse matrix previously provided 
         */
{
    register RESmodel *model = (RESmodel *)inModel;
    register RESinstance *here;

    /*  loop through all the resistor models */
    for( ; model != NULL; model = model->RESnextModel ) {

        /* loop through all the instances of the model */
        for (here = model->RESinstances; here != NULL ;
                here=here->RESnextInstance) {
            
            *(here->RESposPosptr) += here->RESconduct;
            *(here->RESnegNegptr) += here->RESconduct;
            *(here->RESposNegptr) -= here->RESconduct;
            *(here->RESnegPosptr) -= here->RESconduct;
        }
    }
    #ifdef WBPRINT
    // wb dump
    printf("------------------print matrix : res----------------\n");
    spPrint(ckt->CKTmatrix,0,1,1);
    printf("------------------print RHS : res----------------\n");
    //spFileVector(ckt->CKTmatrix,"RHS_trace",ckt->CKTrhs,ckt->CKTirhs);
    spPrintVector(ckt->CKTmatrix,ckt->CKTrhs,ckt->CKTirhs);
    printf("------------------print RHS : res old----------------\n");
    spPrintVector(ckt->CKTmatrix,ckt->CKTrhsOld,ckt->CKTirhsOld);
    printf("------------------print RHS : res Spare----------------\n");
    spPrintVector(ckt->CKTmatrix,ckt->CKTrhsSpare,ckt->CKTirhsSpare);
    #endif

    return(OK);
}
